<template>
  <v-container fluid>
    <v-row align="center">
      <v-col
        class="d-flex"
        cols="12"
        sm="8"
      >
        <v-select
          :items="getShops"
          v-model="selectedShops"
          label="Shops"
          item-value="id"
        >
          <template v-slot:item="data">
            {{ data.item.name }} - {{ data.item.address }}
          </template>
          <template v-slot:selection="data">
            {{ data.item.name }} - {{ data.item.address }}
          </template>
        </v-select>
      </v-col>
    </v-row>
    <v-row>
      <v-col
        class="d-flex"
        cols="12"
        sm="8"
      >
        <v-simple-table>
          <template v-slot:default>
            <thead>
            <tr>
              <th
                class="text-left"
                v-for="(header, index) in tableHeader"
                :key="index"
              >
                {{ header.name }}
              </th>
            </tr>
            </thead>
            <tbody>
            <template v-for="(aspect, keyAspect) in getAspects">
              <tr v-for="(type, keyType) in aspect" :key="keyType" >
                <td>
                  {{ keyAspect }}
                </td>
                <td>
                  {{ keyType }}
                </td>
                <td v-for="(cell, index) in tableCell" :key="index">
                  {{ type[cell.name] || '-' }}
                </td>
              </tr>
            </template>
            </tbody>
          </template>
        </v-simple-table>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
  name: 'Main',
  data: () => ({
    selectedShops: null,
    tableHeader: [
      {
        name: 'Aspect',
      },
      {
        name: 'Term',
      },
      {
        name: 'POS',
      },
      {
        name: 'NEG',
      },
      {
        name: 'FEMALE',
      },
      {
        name: 'MALE',
      },
    ],
    tableCell: [
      {
        name: 'POS',
        text: 'POS',
      },
      {
        name: 'NEG',
        text: 'NEG',
      },
      {
        name: 'FEMALE',
        text: 'FEMALE',
      },
      {
        name: 'MALE',
        text: 'MALE',
      },
    ],
  }),
  computed: {
    ...mapGetters({
      getShops: 'shops/getShops',
      getAspects: 'aspects/getAspects',
    }),
  },
  created() {
    this.fetchShop(1855);
  },
  watch: {
    selectedShops() {
      this.fetchAspectsByBrand();
    },
  },
  methods: {
    fetchShop(id) {
      this.$store.dispatch('shops/fetchShopsRequest', id);
    },
    fetchAspectsByBrand() {
      if (!this.getShops.length || !this.selectedShops) return [];

      return this.$store.dispatch('aspects/setAspectsByShopRequest', this.selectedShops);
    },
  },
};
</script>
